// vcagentDlg.cpp : implementation file
//

#include "stdafx.h"
#include "vcagent.h"
#include "agentctlcharacter.h"
#include "agentctlcharacters.h"
#include "agentctlrequest.h"
#include "comdef.h"
#include "vcagentDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVcagentDlg dialog

CVcagentDlg::CVcagentDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVcagentDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVcagentDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVcagentDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVcagentDlg)
	DDX_Control(pDX, IDOK, m_btnOk);
	DDX_Control(pDX, IDC_CONTROL1, m_Agent);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVcagentDlg, CDialog)
	//{{AFX_MSG_MAP(CVcagentDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVcagentDlg message handlers

BOOL CVcagentDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Initialize our Agent character
	m_Agent.GetCharacters().Load( "Robby", (_variant_t)"c:\\agent\\bin\\robby.acs" );
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVcagentDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVcagentDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVcagentDlg::OnOK() 
{
	CAgentCtlCharacter& robby = m_Agent.GetCharacters().Character( "Robby" );
	robby.Show( (_variant_t)false );
	robby.Play( "Greet" );
	
	RECT rect;
	m_btnOk.GetWindowRect( &rect );

	robby.MoveTo( 
		(short)rect.right, 
		(short)rect.top, 
		(_variant_t)((short)1000) );

	robby.Play( "GestureRight" );
	robby.Speak( (_variant_t)"Click this button, dude!", _variant_t() );
}
